{------------------------------------------------}
{-               -}
{-                   * FWMATH2 *                -}
{-      Copyright (C) .., 1990-2001    -}
{------------------------------------------------}
Unit FWMath2;
interface
uses FWData;

type
  TfmMath2 = class(TObject)
  private
    { Private declarations }
  public
    { Public declarations }
      Procedure QSort(var r: array of double;
                      ma1: integer;
                      var mi: array of integer);
      Procedure RealToRank (var r: array of double;
                            ma1: integer;
                            var CfTied: double);
      Procedure Spirmen;
      Procedure Wilcox;
      Procedure PairWilcox;
      Procedure Pirson(var a1: array of double;
                       ma1: integer;
                       Hd1: ShortString;
                       mean1: double;
                       sigma1: double;
                       var x2: double;
                       var px2: ShortString;
                       var err_txt: string;
                       Is05: boolean;
                       var IsNormal: boolean);
      Procedure Interval(ma1: integer;
                   var a1: array of double;
                   var cl: integer;
                   var int: double;
                   var lmin: double);
      Procedure Frequency(ma1: integer;
                    a1: array of double;
                    mean1: double;
                    sigma1: double;
                    var cl: integer;
                    var lmin: double;
                    int: double;
                    var freedom: integer;
                    var Frq: array of double;
                    var FrqN: array of double;
                    IsUnite: boolean);
  end;

var fmMath2: TfmMath2;
  {------------------------------------------------------}
implementation
uses FWStat0, FWArray, FWMath1, FWTitle, Windows, Dialogs, SysUtils, Math;

Procedure TfmMath2.QSort(var r: array of double;
                         ma1: integer;
                         var mi: array of integer);
  {----------------------------------------------------------}
  {- : 16.07.92                                         -}
  {-                                                        -}
  {- : pp   p               -}
  {-                                                        -}
  {- : r - pp p                 -}
  {-      ma -    p                        -}
  {-      mi -  p p  pp  -}
  {-            r                                    -}
  {-                                                        -}
  {- : r - pp p            -}
  {-                                                        -}
  {- :   .p. p+pp =    -}
  {-                     pp.-.:p, 1985, .99-103. -}
  {----------------------------------------------------------}
Procedure Sort( l: integer;
                s: integer;                //   
                var mi: array of integer);
var
  i,j,mt: integer;
  x,y: double;

begin
  i:=l;
  j:=s;
  x:=r[(l+s) DIV 2];           {     }

  repeat
    while r[i]<x do Inc(i);    {      }
    while x<r[j] do Dec(j);

    if i<=j then
     begin                     {  ,    }
        y:=r[i];
        r[i]:=r[j];
        r[j]:=y;

        mt:=mi[i];
        mi[i]:=mi[j];
        mi[j]:=mt;

        Inc(i);
        Dec(j);
     end;
  until i>j;

  if l<j then sort(l,j,mi);
  if i<s then sort(i,s,mi);
end;

begin             { QSort }
   Sort(0,ma1,mi);
end;

Procedure TfmMath2.RealToRank (var r: array of double;
                               ma1: integer;
                               var CfTied: double);
  {-----------------------------------------------------------}
  {-   : 31.07.96                                        -}
  {-                                                         -}
  {-   : p , p p p   -}
  {-             p        -}
  {-                                                         -}
  {-   : r  - pp p               -}
  {-         ma -    p                      -}
  {-                                                         -}
  {-   : r  - pp p            -}
  {-          CfTied -   p          -}
  {-----------------------------------------------------------}
var
   equal,j,k,l,sum: integer;
   r_equal,RankTied: double;
   mi: array of integer;
   b: array of double;
   IsEqual: boolean;

begin
   SetLength(b,((ma1+1)*2));
   SetLength(mi,((ma1+1)*2));
   for j:=0 to ma1 do
     mi[j]:=j+1;
   QSort(r,ma1,mi);

   //    
   k:=0;
   CfTied:=0.0;
   repeat
      j:=k;
      equal:=1;
      sum:=k; // 1  

      repeat
         Inc(j);
         IsEqual:=(abs(r[j]-r[k])<DataDiffLevel) or ((r[j]-r[k])=0);
         if IsEqual then
                      begin
                         Inc(equal);    //  
                         Inc(sum,(j+1));//   (  1)
                      end;
      until ((r[j]>r[k]) or (j=ma1));

      if equal>1 then
                    begin
                       RankTied:=(sum+1)/equal; //  - 
                       for l:=1 to equal do
                         r[k+l-1]:=RankTied;
                       r_equal:=equal;
                       CfTied:=CfTied+(IntPower(r_equal,3)-r_equal);
                    end
                 else
                    r[k]:=k+1;
     Inc(k,equal);  //      =
     if k=ma1 then r[k]:=k+1;
   until (k>=ma1);

   CfTied:=CfTied/2;
   for j:=0 to ma1 do
     begin
        k:=mi[j]-1; //   1 ,    
        b[k]:=r[j];
     end;
   for j:=0 to ma1 do
     r[j]:=b[j];

   b:=nil;
   mi:=nil;
end;

Procedure TfmMath2.Spirmen;
  {------------------------------------------------------------}
  {-   : 06.01.01                                         -}
  {-                                                          -}
  {-   :  p  pp        -}
  {-         p                                         -}
  {-                                                          -}
  {-   : rs- . pp p                  -}
  {-          rt-  . pp                -}
  {-                                                          -}
  {-   P: RealToRank.                                   -}
  {-                                                          -}
  {-   :  .  pp.-p.  .-   -}
  {-          .:, 1975.- . 45-51.                 -}
  {-           .  .-p.  .- -}
  {-          .:, 1976.- . 268-372.               -}
  {------------------------------------------------------------}
var
   i,j,k,ma1,ma2,nm: integer;
   rs,rs1,s,sm,dsum,tsA,tsB,t: double;
   Hd1,Hd2,prt: ShortString;
   r1,r2: array of double;
   a1,a2: array of double;
begin
   fmTitle.SubTitle6;
   SetLength(r1,(mSize*2));
   SetLength(r2,(mSize*2));
   SetLength(a1,mSize);
   SetLength(a2,mSize);
   fmMain.ProgressBar1.Max:=(sqr(n1)-n1) div 2;

   nm:=0;
   for i:=0 to n1 do
     for k:=(i+1) to n1 do
       begin
          Inc(nm);
          fmMain.ProgressBar1.Position:=nm;
          fmArray.ExtractCol(i,a1,ma1,Hd1);
          fmArray.ExtractCol(k,a2,ma2,Hd2);
          if ma1<>ma2
              then
                  begin
                     writeln(g,' ',Hd1:8,' ',Hd2:8,'     :  ');
                     continue;
           	  end;
          if IsPairEmptyDel
               then fmArray.DelPairEmpty(a1,a2,ma1);
          if IsPairOutDel
                    then fmArray.DelPairOut(a1,a2,ma1);
          for j:=0 to ma1 do
            begin
               r1[j]:=a1[j];
               r2[j]:=a2[j];
            end;
          RealToRank(r1,ma1,tsA);
          RealToRank(r2,ma1,tsB);
          dsum:=0;
          for j:=0 to ma1 do
            dsum:=dsum+sqr(r1[j]-r2[j]);

          s:=ma1+1;           // sm     "integer" 32767
          sm:=IntPower(s,3)-s;//  Power
          if (tsA=0) and (tsB=0)
                then
                    rs:=1-6*dsum/sm //   () 
                else
                    if sm=(tsA+tsB)
                       then
                           begin
                              writeln (g,' ',Hd1:8,' ',Hd2:8,'   ',(ma1+1):4,'       ');
                              continue;
                            end
                       else
                           rs:=1-6*dsum/(sm-(tsA+tsB));  //  

          if rs<>1           // t-
             then
                 begin
                    rs1:=1-sqr(rs);
                    if rs1<=0 then
                                 begin
                                    writeln (g,' ',Hd1:8,' ',Hd2:8,'   ',(ma1+1):4,'  ',rs:8:3,'     t-');
                                    continue;
                                 end
                             else
                                 begin
                                    t:=(abs(rs)*sqrt(ma1-2))/sqrt(rs1);
                       	            prt:=fmMath1.Prob((ma1-2),t,true);
                                 end;
                 end
             else
                 prt:='<0.001';

         if not (IsReliable and (prt='      ')) then
            writeln (g,' ',Hd1:8,' ',Hd2:8,'   ',(ma1+1):4,'  ',rs:8:3,'       ',prt)
       end;

   writeln(g); writeln(g);
   r1:=nil;
   r2:=nil;
   a1:=nil;
   a2:=nil;
end;

{-------  ( )------}
Function ZProb(z: double; Is05: boolean):ShortString;
 begin
    if z>3.29 then Result:='<0.001'
    else if z>2.58 then Result:='<0.01'
    else if z>1.96 then Result:='<0.05'
    else
        if Is05
               then
                   Result:=Plevel
               else
                   Result:='     ';
 end;

Procedure TfmMath2.Wilcox;
  {--------------------------------------------------------------}
  {-   : 10.08.98                                           -}
  {-                                                            -}
  {-   :  U-pp                     -}
  {-                                                            -}
  {-   : g  -                                     -}
  {-         a  - p                               -}
  {-         n  -  p                                   -}
  {-        mx  -    p                         -}
  {-        Hd  -                                -}
  {-                                                            -}
  {-   : z -  z-  u            -}
  {-         zp -  u pp  N pp-  -}
  {-                                                     -}
  {-                                                            -}
  {-   P: RealToRank.                                     -}
  {-                                                            -}
  {-   : UTEST(SSP).                                       -}
  {-           .  .-p.  .-   -}
  {-            .: , 1976, .270-280.                -}
  {--------------------------------------------------------------}
var
   i,k: byte;
   j,l,ma1,ma2,ma,mp,nm: integer;
   fn,fnx,fn1,fn2,r1,r2,s,s0,s1,ts,u,u1,u2,vd,z: double;
   zp,Hd1,Hd2: ShortString;
   a1,a2,r,ss: array of double;
begin
   fmTitle.SubTitle7;
   SetLength(r,(mSize*2));
   SetLength(a1,mSize);
   SetLength(a2,mSize);
   fmMain.ProgressBar1.Max:=(sqr(n1)-n1) div 2;
   nm:=0;
   for i:=0 to n1 do
     for k:=(i+1) to n1 do
       begin
          Inc(nm);
          fmMain.ProgressBar1.Position:=nm;
          if (ShowEqualTitle and (Hd[i]<>Hd[k]))
             then continue;
          fmArray.ExtractCol(i,a1,ma1,Hd1);
          fmArray.ExtractCol(k,a2,ma2,Hd2);
          if ((ma2+1)<8) and ((ma1+1)<8)
              then
                  begin
                     writeln (g,' ',Hd[i]:8,' ',Hd[k]:8,'   ',(ma1+1):4,'  ',(ma1+1):4,'      : n<8');
                     continue;
                  end;

          for j:=0 to ma1 do    {  1   }
            r[j]:=a1[j];
          for j:=0 to ma2 do
            begin
                l:=j+ma1+1;
                r[l]:=a2[j];
            end;
                                {      }
          ma:=ma1+ma2+1;
          RealToRank(r,ma,ts);
          r2:=0.0;              {   }
          r1:=0.0;
          for j:=0 to ma1 do
            r1:=r1+r[j];
          mp:=ma1+1;
          for j:=mp to ma do
            r2:=r2+r[j];
                                  {  U }
          fn:=ma+1;
          fn2:=ma2+1;
          fn1:=ma1+1;
          fnx:=fn1*fn2;
          u2:=fnx+fn2*(fn2+1.0)/2.0-r2;   { u 2-  }
          u1:=fnx-u2;  { u 1- , .. u1+u2=m1*m2 }

          if u2<u1
                  then
                     u:=u2
                  else
                     u:=u1;

          s:=sqrt(fnx*(fn+1.0)/12.0);
          if ts=0
                 then
                     z:=abs(u-fnx*0.5)/s
                 else            {    }
                     begin
                        s0:=(fnx/(fn*(fn-1.0)))*((IntPower(fn,3)-fn)/12.0-ts);
                        if s0>0 then
                                     begin
                                        s1:=sqrt(s0);
                                        z:=abs(u-fnx*0.5)/s1;
                                     end
                        else if s0=0 then
                                     begin
                                        writeln(g,' ',Hd[i]:8,' ',Hd[k]:8,'     : x/0');
                                        continue;
                                     end
                        else if s0<0 then
                                     begin
                                        writeln(g,' ',Hd[i]:8,' ',Hd[k]:9,'     : sqrt(-x)');
                                        continue;
                                     end;
                     end;
          zp:=zprob(z,true);
          if (IsReliable and (zp='')) then continue;
          writeln (g,' ',Hd[i]:8,' ',Hd[k]:8,'   ',(ma1+1):4,'  ',(ma2+1):4,'      ',u:7:2,'     ',zp);
      end;

    writeln(g);writeln(g);
    r:=nil;
    a1:=nil;
    a2:=nil;
end;

Procedure TfmMath2.PairWilcox;
{-----------------------------------------------------------}
{-      : 1.06.98                                      -}
{-                                                         -}
{-      :   -pp        -}
{-                                                         -}
{ 1. .  .-.,1976,.288-290.   }
{ 2. .. .-.,1990,.133-134.                }
{-----------------------------------------------------------}
var
   i,k: byte;
   j,ma1,ma2,mr,nm: integer;
   sum,sum_neg,sum_pos,d1,d2,d,dr,z,ts: double;
   zp: ShortString;
   Hd1,Hd2: ShortString;
   a1,a2: array of double;
   r: array of double;
begin
   fmTitle.SubTitle10;
   SetLength(r,mSize);
   SetLength(a1,mSize);
   SetLength(a2,mSize);
   fmMain.ProgressBar1.Max:=(sqr(n1)-n1) div 2;
   nm:=0;

   for i:=0 to n1 do
     for k:=(i+1) to n1 do
       begin
          Inc(nm);
          fmMain.ProgressBar1.Position:=nm;
          if (ShowEqualTitle and (Hd[i]<>Hd[k]))
              then continue;
          ma1:=mx[i]-1;
          ma2:=mx[k]-1;
          if (ma1<>ma2) then
                      begin
                         writeln(g,' ',Hd[i]:8,' ',Hd[k]:8,'     :  ');
                         Continue;
                      end;
          fmArray.ExtractCol(i,a1,ma1,Hd1);
          fmArray.ExtractCol(k,a2,ma2,Hd2);
          if IsPairEmptyDel
                  then fmArray.DelPairEmpty(a1,a2,ma1);
          if IsPairOutDel
                   then fmArray.DelPairOut(a1,a2,ma1);
          mr:=0;
          for j:=0 to ma1 do    {    }
            begin
               d:=a1[j]-a2[j];
               if d<>0 then
                 begin
                      r[mr]:=abs(d); {NB!:      }
                      Inc(mr);       {       10  -13 !}
                 end;
            end;

          if mr=0   { }
             then
                 begin
                    if (IsReliable=false)
                       then
                           writeln (g,' ',Hd1:8,' ',Hd2:8,'     :  ');
                    Continue;
                 end;
          RealToRank(r,(mr-1),ts);    {   }

          mr:=0;
          sum_neg:=0;
          sum_pos:=0;
          for j:=0 to ma1 do
            begin
                 d:=a[i,j]-a[k,j];
                 if (d<0)
                    then
                        begin
                             sum_neg:=sum_neg-r[mr];
                             Inc(mr);
                        end
                    else if (d>0) then
                        begin
                             sum_pos:=sum_pos+r[mr];
                             Inc(mr);
                        end
            end;

          if abs(sum_neg)>sum_pos //     
            then
                sum:=sum_pos
            else
                sum:=abs(sum_neg);

          dr:=mr;
          d1:=dr*(dr+1)/4;
          d2:=(dr*(dr+1)*(2*dr+1))/24;
          z:=abs(sum-d1)/sqrt(d2);
          zp:=zprob(z,true);    //   

          if (IsReliable and (zp='')) then continue;
          writeln (g,' ',Hd1:8,' ',Hd2:8,'   ',(ma1+1):4,'    ',z:7:2,'     ',zp);
      end;
    writeln(g);writeln(g);
    r:=nil;
    a1:=nil;
    a2:=nil;
end;

{---------------------------------------------------------------}
Procedure TfmMath2.Interval(ma1: integer;
                   var a1: array of double;
                   var cl: integer;
                   var int: double;
                   var lmin: double);
  {-------------------------------------------------------------}
  {-  : 14.09.91                                           -}
  {-                                                           -}
  {-  :    pp p                -}
  {-                                                           -}
  {-  : m  -  p  p x                        -}
  {-        x  - p                              -}
  {-                                                           -}
  {-  : cl  -  p                            -}
  {-         int  - pp p                           -}
  {-         lmin  -  p                     -}
  {-                                                           -}
  {-  P: MinMax(FMath1).                                 -}
  {-                                                           -}
  {-  : p .., ..       -}
  {-           pp   .-.:   -}
  {-          ,1989, .31.                          -}
  {-------------------------------------------------------------}
var
   d,amin,amax: double;

begin
   cl:=round(5*log10(ma1));
   fmMath1.MinMax(a1,ma1,amin,amax);
   if cl=0 then Exit;
   int:=(amax-amin)*1.02/cl;
   d:=0.01*int;
   lmin:=amin-d;
end;

{-----------------------------------}
Procedure ReSetFrq(var cl: integer;
                        m: integer;
                  freedom: integer;
                 var lmin: double;
                      int: double;
                 var FrqN: array of double;
                  var Frq: array of double);
//      
var
   j,k: integer;
   MinNmb: double;
   cl1: integer;
begin
   cl1:=cl-1;
   //     
   if m>50  //     .., 1990
         then
             begin
               if freedom>=6
                 then
                     MinNmb:=0.5
                 else if (freedom<6) and (freedom>2) then
                     MinNmb:=1.0
                 else if freedom=2 then
                     MinNmb:=2.0
                 else MinNmb:=4.0;
             end
         else
             begin
                if (m>=40) and (freedom>=8)   // .,1976
                   then
                       MinNmb:=1.0
                   else
                       MinNmb:=4.0;
             end;

   //   , ..  
   if (FrqN[0]>=MinNmb) and (FrqN[cl1]>=MinNmb)
       then Exit;

   if (FrqN[0]<MinNmb) then          //  
       begin
          k:=0;
          repeat
             Inc(k);
             FrqN[k]:=FrqN[k-1]+FrqN[k];
             FrqN[k-1]:=-99999;
             Frq[k]:=Frq[k-1]+Frq[k];
             Frq[k-1]:=-99999;
             lmin:=lmin+int;
          until (FrqN[k]>=MinNmb) or (k=cl1);
       end;

  if (FrqN[cl1]<MinNmb) then        //  
       begin
          k:=cl1;
          repeat
             Dec(k);
             FrqN[k]:=FrqN[k+1]+FrqN[k];
             FrqN[k+1]:=-99999;
             Frq[k]:=Frq[k+1]+Frq[k];
             Frq[k+1]:=-99999;
          until (FrqN[k]>=MinNmb) or (k=0);
       end;

   k:=0;                        // 
   for j:=0 to cl1 do
     if FrqN[j]<>-99999 then
         begin
            FrqN[k]:=FrqN[j];
            Frq[k]:=Frq[j];
            Inc(k);
         end;
   cl:=k;
end;

Procedure TfmMath2.Frequency(ma1: integer;
                    a1: array of double;
                    mean1: double;
                    sigma1: double;
                    var cl: integer;
                    var lmin: double;
                    int: double;
                    var freedom: integer;
                    var Frq: array of double;
                    var FrqN: array of double;
                    IsUnite: boolean);
  {-------------------------------------------------------------}
  {-  : 28.03.00                                           -}
  {-                                                           -}
  {-  :  p  p             -}
  {-           p                      -}
  {-                                                           -}
  {-  : m  -  p  p x                        -}
  {-        x  - p                              -}
  {-    mean1  - p                        -}
  {-   sigma1  - pp                -}
  {-                                                           -}
  {-  : FrqN - p                       -}
  {-         Frq - p                         -}
  {-         int - p                                    -}
  {-          cl -                                 -}
  {-                                                           -}
  {-  P: Interval(FMath20).                              -}
  {-                                                           -}
  {-  :  .. p.-.:..-1990, .84-85.  -}
  {-------------------------------------------------------------}
var
   cf1,cf2,f,lmax1,lmin1,lavr1,t2: double;
   j,k,nmb: integer;
begin
   freedom:=cl-3;                {    }
   lmin1:=lmin;
   lmax1:=lmin1+int;
   k:=0;
   cf1:=1/sqrt(2*Pi);
   cf2:=(ma1+1)*int/sigma1;

   repeat
       nmb:=0;
       for j:=0 to ma1 do        {    }
         begin
            if (a1[j]>lmin1) and (a1[j]<=lmax1)
              then Inc(nmb);
         end;
       Frq[k]:=nmb;

       lavr1:=(lmax1+lmin1)/2;    {      }
       t2:=sqr((lavr1-mean1)/sigma1);
       f:=cf1*exp(-t2/2);
       frqN[k]:=cf2*f;

       lmin1:=lmin1+int;
       lmax1:=lmin1+int;
       Inc(k);
   until k=cl;

   if IsUnite
      then ReSetFrq(cl,ma1,freedom,lmin,int,FrqN,Frq); //  
   freedom:=cl-3;                {    }
end;


{--------------------------------------------}
Function X2sign(frd:integer;
                x2: double;
                Is05: boolean;
                var px2: ShortString): boolean;
var
   zl : array[1..3] of double;

Function X2Level(frd: integer; sg: double): double;
{       a = 5, 1  0.1% }
var
   a,b,rf: double;
begin
   rf:=frd;
   a:=2/(9*rf);
   b:=1.0-a+sg*sqrt(a);
   Result:=rf*Power(b,3.0);
end;

begin
    zl[1]:=X2Level(frd,1.96);
    zl[2]:=X2Level(frd,2.58);
    zl[3]:=X2Level(frd,3.29);

    Result:=false;
    if (x2-zl[3])>0 then px2:='<0.001'
    else if (x2-zl[2])>0 then px2:='<0.01'
    else if (x2-zl[1])>0 then px2:='<0.05'
    else
        begin
           Result:=true;
           if Is05
               then
                   px2:=Plevel
               else
                   px2:='     ';
        end;
end;

{--------------------------------------------}
Procedure TfmMath2.Pirson(var a1: array of double;
                          ma1: integer;
                          Hd1: ShortString;
                          mean1: double;
                          sigma1: double;
                          var x2: double;
                          var px2: ShortString;
                          var err_txt: string;
                          Is05: boolean;
                          var IsNormal: boolean);
  {--------------------------------------------------------------}
  {-   : 14.08.95                                           -}
  {-                                                            -}
  {-   :   pp  p      -}
  {-          pp X2 p                             -}
  {-                                                            -}
  {-   : a  - p                               -}
  {-         n  -  p                                   -}
  {-         mx -    p                         -}
  {-       mean - p                        -}
  {-      sigma - pp                -}
  {-         Hd -                                -}
  {-                                                            -}
  {-   : X2  -  X2                                 -}
  {-          px2 - p                           -}
  {-                                                            -}
  {-   P: Average, MinMax(FMath1).                        -}
  {-                                                            -}
  {-   :1. .. p.-.:..-1990,c.138-145 -}
  {-         2. .  .-p.  .-  -}
  {-            .: , 1976, .136-137,295-296.        -}
  {-         3.p .., ..       -}
  {-              pp   .-             -}
  {-            .:  ,1989,.30-33, 133-136.  -}
  {-         4.GFIT (IMSL)                                      -}
  {--------------------------------------------------------------}
var
   cl,frd,k: integer;
   chi,int,sumx2,lmin: double;
   frq,frqN: array of double;
begin
   err_txt:='';
   if sigma1=0
          then
             begin
                x2:=vEmpty;
                px2:='';
                err_txt:='@ = 0';
                IsNormal:=true; //  
                Exit;
             end;
   Interval(ma1,a1,cl,int,lmin);
   SetLength(frq,cl); //   Frequency  
   SetLength(frqN,cl);
   Frequency(ma1,a1,mean1,sigma1,cl,lmin,int,frd,Frq,FrqN,true);
   SetLength(Frq,cl);
   SetLength(FrqN,cl);
   if frd>0
           then
               begin
                  sumX2:=0;
                  for k:=0 to (cl-1) do
                    begin
                       chi:=sqr(frq[k]-frqN[k])/frqN[k];
                       sumX2:=sumX2+chi;
                    end;
                  x2:=sumX2;
                  IsNormal:=x2sign(frd,sumx2,Is05,px2);
               end
           else
               begin
                  x2:=vEmpty;
                  px2:='    ';
                  err_txt:='  . = 0';
                  IsNormal:=true; //  
               end;
   Frq:=nil;
   FrqN:=nil;
end;
end.
